#! /usr/bin/perl
#Name: R3-status.pl
#Project: R3 control
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 2.0
#Creation date: 05.06.2011
#Update to v2.0: 03.01.2012
#Copyright: (c) 2011 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Server script displays the status of the rover. Script is called by Javascript from control panel of the webpage

use strict;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);

my $type_style =  '; font-family:serif,Times,serif; font-size:12px; color:#000000"';
my $command = param("command");
my $MoveLength = param("MoveLength");
my $MoveLengthNumber = 0;
my $text_line = "";
my $Servo_01 = 0;
my $Servo_02 = 0;
my $Servo_03 = 0;
my $Servo_04 = 0;
my $Servo_05 = 0;

print "Content-type: text/html\n\n";
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">' . "\n";
print "<html><head><title>Test-Ausgabe</title>" . "\n";

print "</head><body>";
print '<table border="0" cellpadding="0" cellspacing="0"><tr>' . "\n";

if($command ne ""){
  open(FILEIN,'< current-coordinates.txt') || die '<td style="background-color:#FF0000' . $type_style . '>Can not open current-coordinates.txt. Please try again.</td></tr></table></body></html>';
    $text_line = <FILEIN>;
  close (FILEIN);

  $Servo_01 = substr($text_line, 0, 5);
  $Servo_02 = substr($text_line, 6, 5);
  $Servo_03 = substr($text_line, 12, 5);
  $Servo_04 = substr($text_line, 18, 5);
  $Servo_05 = substr($text_line, 24, 5);

  if($MoveLength eq "a"){
    $MoveLengthNumber = 1;
  }
  if($MoveLength eq "b"){
    $MoveLengthNumber = 10;
  }
  if($MoveLength eq "c"){
    $MoveLengthNumber = 100;
  }

  if($command eq "a"){
    $Servo_01 += $MoveLengthNumber;
  }
  if($command eq "b"){
    $Servo_01 -= $MoveLengthNumber;
  }

  if($command eq "c"){
    $Servo_02 += $MoveLengthNumber;
  }
  if($command eq "d"){
    $Servo_02 -= $MoveLengthNumber;
  }
  if($command eq "e"){
    $Servo_03 += $MoveLengthNumber;
  }
  if($command eq "f"){
    $Servo_03 -= $MoveLengthNumber;
  }
  if($command eq "g"){
    $Servo_04 += $MoveLengthNumber;
  }
  if($command eq "h"){
    $Servo_04 -= $MoveLengthNumber;
  }
  if($command eq "i"){
    $Servo_05 += $MoveLengthNumber;
  }
  if($command eq "j"){
    $Servo_05 -= $MoveLengthNumber;
  }

  if($command eq "Square"){
    $command="D";
  }


  if($Servo_01 < 500){
    $Servo_01 = 500;
  }
  if($Servo_01 > 2500){
    $Servo_01 = 2500;
  }

  if($Servo_02 < 500){
    $Servo_02 = 500;
  }
  if($Servo_02 > 2500){
    $Servo_02 = 2500;
  }

  if($Servo_03 < 500){
    $Servo_03 = 500;
  }
  if($Servo_03 > 2500){
    $Servo_03 = 2500;
  }

  if($Servo_04 < 500){
    $Servo_04 = 500;
  }
  if($Servo_04 > 2500){
    $Servo_04 = 2500;
  }

  if($Servo_05 < 500){
    $Servo_05 = 500;
  }
  if($Servo_05 > 2500){
    $Servo_05 = 2500;
  }


  print '<td style="background-color:#CCCCCC' . $type_style . '">' . $Servo_01 . ' ' . $Servo_02 . ' ' . $Servo_03 . ' ' . $Servo_04 . ' ' . $Servo_05 . ' ' . '</td>';

  if($command eq "Del"){
    `rm stored-coordinates.txt`;
    $command="All coordinated deleted";
  }
  else{
    open(DATEIOUT,'> nextCommand.tmp') || die '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Can not open nextCommand.txt. Please try again.</td></tr></table></body></html>';
      print DATEIOUT $command . $MoveLength ."_\n";
    close (DATEIOUT);
    `mv nextCommand.tmp nextCommand.txt`;
  }

  print '</tr><tr><td style="background-color:#00FF00' . $type_style . '">Command = ' . $command . ' MoveLength = ' . $MoveLength . ' transmitted</td>';
}
else{
  print '<td style="background-color:#FF0000' . $type_style . '">No command received!</td>';
}



print "</tr></table></body></html>" . "\n";


